#include "gis.h"
#include <stdlib.h>
#include <math.h>

#define KOLNEG 1048576

char *sd;
char sd1[32];

int arcode;
double categ, step, maximum;

FILE *fsteps;            

long i;

double steplist[512];

float negcat[KOLNEG];				// for negative in hist
long negcou[KOLNEG];

int steprow;

long   negnum, index;

int get_stats (char *name, char *mapset, struct Cell_stats *statf, int quiet,
DCELL old_min, DCELL old_max, long nlevels, char *method, int type, double step0, int
palette, FILE *fst)
{
    int met;

    struct Colors colr;
    struct FPRange range;					

    DCELL min;							
    DCELL max;							
    int any;
    int zero;

    DCELL znmin, znmax, Ampl;

    CELL cat;							
    FCELL fcat;
    
    long count;
    long sum;

    int pack, cnt;
    long nn;
    
    char *filename;

    char *filecol;

    
    char *s[3];
    char s1[16], s2[16], s3[16];

    long number, ind, picked, sumpicked;
    int nLev;

    long rasp;

    double zcolor, zcolorpr, memo;

    int i1,j1;
    double start, end, stepc, curr, spred;
    double diagpred, diagcurr;

    long limit;
    float Rf, Gf, Bf;
    int R,G,B,  Rpred,Gpred,Bpred;

    int cicle, proc;
    float delta_r, delta_g, delta_b;
    int bord1, bord2, bord3, bord11;
    
    int bord4, bord5, bord6;
    
    float cb1, cb11, cb2, cb3, cb4, cb5;
    

    int fd;
    
    FCELL *cell;
    
    int row, nrows, ncols;
    
    int area_lin( FCELL*, long*, struct Cell_stats* );		
    
    int getall (FCELL *cell, int n, struct Cell_stats *s, DCELL min, DCELL max);
    
    int sort_fun( const FCELL *, const FCELL * );

    sd = sd1;

    G_read_fp_range( name, mapset, &range );
    G_get_fp_range_min_max( &range, &min, &max );    
    
    if (!quiet) 
    	fprintf(stdout, "Data Range = %lf   %lf\n",  min,  max);
    
    negnum = 0; nn = 0;
    
    fd = G_open_cell_old (name, mapset);
    if (fd < 0)
	exit(1);
    
    nrows = G_window_rows();
    ncols = G_window_cols();
    
    steprow = (int) ( nrows*ncols / KOLNEG ) + 1;	// > 1 if
    							// data numbers > negcat[]
    cell =  (FCELL*)G_allocate_cell_buf();
   
    for ( row = 0; row < nrows; row+=steprow )		// razregenie using steprow
    {

	if (G_get_f_raster_row (fd, cell, row) < 0)
	    break;

        getall ( cell, ncols, statf, old_min, old_max );
	
    }

    qsort( negcat, negnum, sizeof(negcat[0]), (void *)sort_fun );
    
    sum = negnum;
    
    //if (!quiet) fprintf(stdout, "\nAnalised raster points = %ld\n", sum);
    
    G_init_colors(&colr);

    if ( old_min == -99999999 ) old_min = min;	 // use data range, else 
    if ( old_max == 99999999 ) old_max = max;	 // use user input
    
    if (!quiet) 
      fprintf(stdout, "New Range = %lf   %lf\n",(double)old_min, (double)old_max);
    
    number = sum; 

    nLev = nlevels;
    
    if ( nlevels < 1 ) nLev = 28;
  
    znmin = min; znmax = max; Ampl = znmax - znmin;

    limit = (long) (number/nLev);

    sumpicked = 0;

    picked = 0; ind = 0;
    rasp = sum;

    if (palette < 10) 						// 0 - 9
    { 
       Rf = 0, Gf = 0, Bf = 155;	
       Rpred = 0; Gpred = 0; Bpred = 155;
    }
    if ((palette>9)&&(palette<20)) 				// 10 - 19
    { 
       Rf = 0, Gf = /*204*/155, Bf = 255; 
       Rpred = 0; Gpred = 155; Bpred = 255;
    }
    zcolorpr = zcolor;
    
    i = -1;
    
    arcode = 0;						// default = "area"
    if ( strcmp(method, "area")==0 ) arcode = 0;
    if ( strcmp(method, "line")==0 ) arcode = 1;

    if ( fst!=NULL )					// read steps from file
    {
      arcode = 2;
      fsteps = fst;
      
      s[0] = s1; s[1] = s2; s[2] = s3;
      
     for (i1=0; i1<512; i1++)  steplist[i1]=9999999999;
      
     i1 = 0; j1 = 0;
     spred=-9999; maximum = -9999999;
     while( fscanf( fsteps, "%s", s[i1]   ) != EOF  )
     {
       	switch ( i1 )
	{
	  case 0: sscanf( s[i1], "%lf", &start  );
	          diagcurr = start;
		  break;
	  case 1: sscanf( s[i1], "%lf", &end  );
		  break;
	  case 2: sscanf( s[i1], "%lf", &stepc  );
		  if (j1>0) if ( diagcurr!=diagpred ) {steplist[j1]=-9999999;j1++;}
	          for ( curr=start; curr<=end; curr+=stepc ) 
                    if ( curr!=spred ) 
		    {
		      steplist[j1] = curr; spred = curr; 
		      
		      j1++;
		      if (curr>maximum) { maximum=curr; nLev=j1; }
		    }

		  i1=-1;
		  fprintf(stdout, "double: %lf %lf %lf\n", start, end, stepc );
		  fprintf(stdout, "strings: %s %s %s\n", s[0], s[1], s[2] );
		  diagpred=end;
		  break;
	}
	i1++;
     }
     //for ( i1=0; i1<j1; i1++ ) fprintf(stdout, "steplist: %lf\n", steplist[i1] );
    }							// end fst arcode=2

    if ( arcode == 1 )					// linear
    {
      categ = old_min;
      maximum = old_max;
      
      step = step0;
      if (step==0) step = -9999;
      if ( step==-9999 )				// if not in command line
         step = (old_max-old_min)/nLev;			// calculate it
      else nLev = (old_max-old_min)/step;		// and it
    }
    
    index = 0;
    nLev--;
    while (area_lin(&fcat, &count,statf))		// the mine circle...
    {
    
        if ( arcode == 0 )	
	  categ = (double)fcat;
	  
        if ( categ!=-9999999 )
	if ( categ<old_min ) goto m77;
	if ( categ>old_max) goto m77;
    
        i++;
	
	picked += count;					   
        sumpicked += count;
	
	if(i==rasp) picked = limit;
	
	if ( arcode > 0 ) picked=limit;	
		
        if ( picked >= limit )
	{
           sprintf( sd, "%lf", categ );

	   //fprintf(stdout, "zcateg = %lf, %s\n", categ, sd);
	   
           zcolor = categ;

           if ( palette < 10 )
	   {
	     switch ( palette )
	     {  //        sinii      golub     zelen     gelt      krasn     rozov
		case 0: cb1=0.11; cb11=0.55; cb2=0.65; cb3=0.75; cb4=0.93; cb5=0.96;
			break;
		case 1: cb1=0.07; cb11=0.55; cb2=0.65; cb3=0.72; cb4=0.95; cb5=0.97;
			break;
		case 2: cb1=0.05; cb11=0.31; cb2=0.45; cb3=0.56; cb4=0.93; cb5=0.96;
			break;
		case 3: cb1=0.04; cb11=0.55; cb2=0.65; cb3=0.75; cb4=0.93; cb5=0.96;	
		        break;
		case 4: cb1=0.04; cb11=0.45; cb2=0.55; cb3=0.70; cb4=0.93; cb5=0.96;
		        break;
		case 5: cb1=0.04; cb11=0.45; cb2=0.60; cb3=0.70; cb4=0.93; cb5=0.96;
		        break;
		default: cb1=0.11; cb11=0.55; cb2=0.65; cb3=0.75; cb4=0.93; cb5=0.96;
	     }
	     						// !!-3   !!-1            !!-2
	     bord1 = (int) (nLev * cb1);		// 0.11   0.11    sinii   0.11
             bord11 =(int) (nLev * cb11);		// 0.55   0.31    golub   0.45
             bord2 = (int) (nLev * cb2);		// 0.65   0.45	   zelen  0.55
             bord3 = (int) (nLev * cb3);		// 0.72   0.56	   gelt   0.66
	   
	     bord4 = (int) (nLev * cb4);		// 0.95   0.95    krasn   0.95
	     bord5 = (int) (nLev * cb5);		// 0.97   0.97    rozov   0.97

	     if ( ind<=bord1 )                   cicle = 1;
	     if ( (ind>bord1) & (ind<=bord11))   cicle = 11;
	     if ( (ind>bord11) & (ind<=bord2))   cicle = 2;
	     if ( (ind>bord2) & (ind<=bord3) )   cicle = 3;
	     if ( (ind>bord3) & (ind<=bord4) )   cicle = 4;
	     if ( (ind>bord4) & (ind<=bord5) )   cicle = 5;
	     if ( (ind>bord5) & (ind<=nLev)  )   cicle = 6;

	     switch ( cicle )
	     {
		case 1:
			delta_r = 0; delta_g = 0; delta_b=(float)100/bord1;
			break;
		case 11:
			delta_r=0;delta_g=(float)255/(bord11-bord1);delta_b=0;
			break;

		case 2:
			delta_r=0; delta_g=0;delta_b=-(float)255/(bord2-bord11);
			break;
		case 3:
		        delta_r=(float)255/(bord3-bord2);delta_g=0; delta_b=0;	
		        break;
		case 4:                      //190/-ne tak jarko-krasnyi 
		        delta_r=0; delta_g=-(float)255/(bord4-bord3);delta_b=0;
		        break;
		    
		case 5:
		        delta_r=0; delta_g=0;delta_b=(float)100/(bord5-bord4);
		        break;
	     }
           }


           if ( (palette > 9) && (palette < 20) )		// light-blue
	   {
	     switch ( palette )
	     {
		case 10: cb1=0.27; cb11=0.45; cb2=0.70; cb3=0.88; cb4=0.92; cb5=0.97;
			break;
		case 11: cb1=0.17; cb11=0.35; cb2=0.65; cb3=0.85; cb4=0.93; cb5=0.96;
			break;

		case 12: cb1=0.10; cb11=0.25; cb2=0.43; cb3=0.65; cb4=0.95; cb5=0.97;
			break;
		case 13: cb1=0.14; cb11=0.33; cb2=0.45; cb3=0.87; cb4=0.91; cb5=0.95;	
		        break;
		case 14: ;
		        break;
		        
		case 15: ;
		        break;
		default: cb1=0.27; cb11=0.45; cb2=0.70; cb3=0.88; cb4=0.92; cb5=0.97;
	     }
 						  //         !!-1    !!-2-sr
             bord1 = (int) nLev * cb1;           //golub    0.14    0.10     0.17
             bord11 =(int) nLev * cb11;           //zelen    0.33    0.25     0.35
             bord2 = (int) nLev * cb2;           //gelt     0.45    0.43     0.65
             bord3 = (int) nLev * cb3;           //krasn    0.87    0.65     0.85
	   
	     bord4 = (int) nLev * cb4;		 //fiolet    0.91    0.95     0.93
	     bord5 = (int) nLev * cb5;		 //t-fiolet  0.95    0.97     0.96


	     if ( ind<=bord1 )                  cicle = 1;
	     if ( (ind>bord1) & (ind<=bord11) ) cicle = 11;
	     if ( (ind>bord11) & (ind<=bord2) ) cicle = 2;
	     if ( (ind>bord2) & (ind<=bord3) )  cicle = 3;
	     if ( (ind>bord3) & (ind<=bord4) )   cicle = 4;
	     if ( (ind>bord4) & (ind<=bord5) )   cicle = 5;
	     if ( (ind>bord5) & (ind<=nLev)  )   cicle = 6;

	     switch ( cicle )
	     {
		case 1:
			delta_r = 0; delta_g = (float)/*51*/100/(bord1); delta_b=0;        // t-golub->golub
			break;
		case 11:
			delta_r=0;delta_g=0;delta_b=-(float)255/(bord11-bord1);     // golub->zelen
			break;

		case 2:
		        delta_r=(float)255/(bord2-bord11);delta_g=0; delta_b=0;	    // zelen->gelt
			break;
		case 3:
		        delta_r=0; delta_g=-(float)255/(bord3-bord2);delta_b=0;	    // gelty-krasn
		        break;
		case 4:                       
		        delta_r=0; delta_g=0; delta_b=(float)255/(bord4-bord3);     // krasny->fiolet
		        break;
		    
		case 5:								    // fiolet->t-fiolet
		        delta_r=-(float)102/(bord5-bord4); delta_g=0;delta_b=-(float)51/(bord5-bord4);
		        break;

	     }
	   }


	   if ( ind > 0 )
	   {
		Rf = Rf + delta_r; Gf = Gf + delta_g; 
		Bf = Bf + delta_b;
	   }

	   R=(int)Rf; G = (int)Gf; B = (int)Bf;

	   m4:
	   ind++;

           if ( ind == 1 ) 
	       {Rpred = 0; Gpred = 0; Bpred = 155; zcolorpr = znmin;}

           if ( type != 1 ) type = 0;				// 0 - gradualy 1 - contour

           if ( zcolor==-9999999 ) {zcolorpr=-9999999; goto m77;}  // to make white holes
           if ( zcolorpr!=-9999999 )				   // for area3 mode
	   
              if ( type == 0 )								
		G_add_d_raster_color_rule(&zcolorpr,Rpred,Gpred,Bpred, &zcolor,R,G,B, &colr);
              else
                G_add_d_raster_color_rule(&zcolorpr,Rpred,Gpred,Bpred, &zcolor,Rpred,Gpred,Bpred, &colr);

	   Rpred = R; Gpred = G; Bpred = B; zcolorpr = zcolor;

           if ( ind<nLev ) limit = (long) ( (number-sumpicked)/(nLev-ind) );
           picked = 0;

	   if( (i==rasp) & (ind==nLev) ) 
		goto m4;
           if ( i>rasp ) goto m5;
	  

	}													// picked
     if (ind >=nLev) break;
    m77:;
    }														//while

    m5:
    if (palette==0) {R = 255; G = 0; B = 150; }
    zcolor = znmax + 1;
    
    if ( type == 0 )
    	G_add_d_raster_color_rule(&zcolorpr,Rpred,Gpred,Bpred, &zcolor,R,G,B, &colr);
    else
	G_add_d_raster_color_rule(&zcolorpr,Rpred,Gpred,Bpred, &zcolor,Rpred,Gpred,Bpred,  &colr);

    n1:

    G_write_colors(name, mapset, &colr);

    G_free_colors(&colr);


    if (row < nrows)
	exit(1);
    G_close_cell (fd);
    G_free (cell);
    if (!quiet) G_percent (row, nrows, 2);

    return 0;
    
    
}


int area_lin( FCELL *fcat, long *count, struct Cell_stats *statf )
{
  if ( arcode == 0 )					
  {
      if ( index < negnum )
      {
        *fcat = negcat[index]; *count = 1; 
	
        index++;
      
        return 1;
      }
      else
        return 0;
      
  }
      
  if ( arcode == 1 )					// linear
  {
    count = 0;
    categ += step;
    
    if ( categ <= maximum ) 
      return 1;
    else
      return 0;
   }
  
  if ( arcode==2 )
  {
     categ = steplist[ i+1 ];

     if ( categ <= maximum ) 
       return 1;
     else return 0;
     
  }  // end arcode==2

}    
    

int sort_fun( const FCELL * a, const FCELL * b )
{
  int e;
  
  if ( *a < *b ) e = -1;
  if ( *a == *b ) e = 0;
  if ( *a > *b ) e =  1;
  
  return e;
}


int getall (FCELL *cell, int n, struct Cell_stats *s, DCELL min, DCELL max)
{
    FCELL cat;
    int N;

    if (n <= 0) return 1;

    if ((N = s->N) == 0)
    {
	cat = *cell++;
        while(G_is_f_null_value(&cat))
	{
            s->null_data_count++;
	    cat = *cell++;
	    n--;
        }
    }
    while (n-- > 0)
    {
	cat = *cell++;
        if(G_is_f_null_value(&cat))
        {
            s->null_data_count++;
            continue;
        }
	
	if ( ( cat >= min ) && ( cat <= max ) )
	   negcat[negnum++] = cat;
	
   } 

    return 0;
}
